/* f9.c contains these functions for monopoly:
        drawhouse(),   em(prop, draw),   drawhotel(),
    maketransmenu(),   servicetransmenu(),       */

#include "mono:defines"
#include "mono:xvariables"


VOID drawhouse(prop, draw)
USHORT prop;
BOOL draw;
{
/*  draw or erase house\s in white or black  */
USHORT bg, atx, aty, orient, pen;
USHORT iter;

if (prop == 1)
   {
   bg=purple;
   pen=white;
   atx=240;
   aty=172;
   orient=0;
   goto drawhous;
   }
if (prop == 3)
   {
   bg=purple;
   pen=white;
   atx=198;
   aty=172;
   orient=0;
   goto drawhous;
   }
if (prop == 6)
   {
   bg=lt_blue;
   pen=black;
   atx=123;
   aty=172;
   orient=0;
   goto drawhous;
   }
if (prop == 8)
   {
   bg=lt_blue;
   pen=black;
   atx=81;
   aty=172;
   orient=0;
   goto drawhous;
   }
if (prop == 9)
   {
   bg=lt_blue;
   pen=black;
   atx=61;
   aty=172;
   orient=0;
   goto drawhous;
   }
if (prop == 11)
   {
   bg=maroon;
   pen=black;
   atx=52;
   aty=159;
   orient=1;
   goto drawhous;
   }
if (prop == 13)
   {
   bg=maroon;
   pen=black;
   atx=52;
   aty=125;
   orient=1;
   goto drawhous;
   }
if (prop == 14)
   {
   bg=maroon;
   pen=black;
   atx=52;
   aty=111;
   orient=1;
   goto drawhous;
   }
if (prop == 16)
   {
   bg=orange;
   pen=white;
   atx=52;
   aty=73;
   orient=1;
   goto drawhous;
   }
if (prop == 18)
   {
   bg=orange;
   pen=white;
   atx=52;
   aty=43;
   orient=1;
   goto drawhous;
   }
if (prop == 19)
   {
   bg=orange;
   pen=white;
   atx=52;
   aty=28;
   orient=1;
   goto drawhous;
   }
if (prop == 21)
   {
   bg=red;
   pen=white;
   atx=60;
   aty=21;
   orient=0;
   goto drawhous;
   }
if (prop == 23)
   {
   bg=red;
   pen=white;
   atx=102;
   aty=21;
   orient=0;
   goto drawhous;
   }
if (prop == 24)
   {
   bg=red;
   pen=white;
   atx=123;
   aty=21;
   orient=0;
   goto drawhous;
   }
if (prop == 26)
   {
   bg=yellow;
   pen=black;
   atx=177;
   aty=21;
   orient=0;
   goto drawhous;
   }
if (prop == 27)
   {
   bg=yellow;
   pen=black;
   atx=198;
   aty=21;
   orient=0;
   goto drawhous;
   }
if (prop == 29)
   {
   bg=yellow;
   pen=black;
   atx=241;
   aty=21;
   orient=0;
   goto drawhous;
   }
if (prop == 31)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=28;
   orient=2;
   goto drawhous;
   }
if (prop == 32)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=43;
   orient=2;
   goto drawhous;
   }
if (prop == 34)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=73;
   orient=2;
   goto drawhous;
   }
if (prop == 37)
   {
   bg=dk_blue;
   pen=white;
   atx=260;
   aty=128;
   orient=2;
   goto drawhous;
   }
if (prop == 39)
   {
   bg=dk_blue;
   pen=white;
   atx=260;
   aty=158;
   orient=2;
   }
drawhous:
if (!notplaying[0])  RemIBob(Redbob, &screen1->RastPort, vport1);
if (!notplaying[1])  RemIBob(Greenbob, &screen1->RastPort, vport1);
if (!notplaying[2])  RemIBob(Bluebob, &screen1->RastPort, vport1);
if (!notplaying[3])  RemIBob(Yellowbob, &screen1->RastPort, vport1);
if (draw)
   {
   SetAPen(rportboard, pen);
   if (orient == 0)
      {
      if (numhouses[prop] >= 1)
         {
         WritePixel(rportboard, atx+3, aty+1);
         for (iter=2; iter<5; iter++)  WritePixel(rportboard, atx+iter, aty+2);
         for (iter=1; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+3);
         for (iter=1; iter<3; iter++)  WritePixel(rportboard, atx+iter, aty+4);
         for (iter=1; iter<3; iter++)  WritePixel(rportboard, atx+iter, aty+5);
         for (iter=4; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+4);
         for (iter=4; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+5);
         }
      if (numhouses[prop] >= 2)
         {
         WritePixel(rportboard, atx+7, aty+1);
         for (iter=6; iter<9; iter++)  WritePixel(rportboard, atx+iter, aty+2);
         for (iter=6; iter<10; iter++)  WritePixel(rportboard, atx+iter, aty+3);
         for (iter=4; iter<6; iter++)  WritePixel(rportboard, atx+6, aty+iter);
         for (iter=8; iter<10; iter++)  WritePixel(rportboard, atx+iter, aty+4);
         for (iter=8; iter<10; iter++)  WritePixel(rportboard, atx+iter, aty+5);
         }
      if (numhouses[prop] >= 3)
         {
         WritePixel(rportboard, atx+11, aty+1);
         for (iter=10; iter<13; iter++)  WritePixel(rportboard, atx+iter, aty+2);
         for (iter=10; iter<14; iter++)  WritePixel(rportboard, atx+iter, aty+3);
         for (iter=4; iter<6; iter++)  WritePixel(rportboard, atx+10, aty+iter);
         for (iter=12; iter<14; iter++)  WritePixel(rportboard, atx+iter, aty+4);
         for (iter=12; iter<14; iter++)  WritePixel(rportboard, atx+iter, aty+5);
         }
      if (numhouses[prop] == 4)
         {
         WritePixel(rportboard, atx+15, aty+1);
         for (iter=14; iter<17; iter++)  WritePixel(rportboard, atx+iter, aty+2);
         for (iter=14; iter<18; iter++)  WritePixel(rportboard, atx+iter, aty+3);
         for (iter=4; iter<6; iter++)  WritePixel(rportboard, atx+14, aty+iter);
         for (iter=16; iter<18; iter++)  WritePixel(rportboard, atx+iter, aty+4);
         for (iter=16; iter<18; iter++)  WritePixel(rportboard, atx+iter, aty+5);
         }
      }
   if (orient == 2)
      {
      if (numhouses[prop] == 1)
         {
     for (iter=0; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty);
     for (iter=0; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+3);
     for (iter=2; iter<7; iter++)  WritePixel(rportboard, atx+iter, aty+1);
     for (iter=2; iter<7; iter++)  WritePixel(rportboard, atx+iter, aty+2);
     }
      if (numhouses[prop] >= 2)
         {
     for (iter=0; iter<2; iter++)  WritePixel(rportboard, atx+iter, aty);
     for (iter=0; iter<2; iter++)  WritePixel(rportboard, atx+iter, aty+3);
     for (iter=0; iter<2; iter++)  WritePixel(rportboard, atx+iter, aty+6);
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+2, aty+iter);
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+3, aty+iter);
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+4, aty+iter);
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+5, aty+iter);
     WritePixel(rportboard, atx+6, aty+1);
     WritePixel(rportboard, atx+6, aty+2);
     WritePixel(rportboard, atx+6, aty+4);
     WritePixel(rportboard, atx+6, aty+5);
     }
      if (numhouses[prop] >= 3)
         {
     for (iter=0; iter<2; iter++)  WritePixel(rportboard, atx+iter, aty+9);      
     for (iter=2; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+7);      
     for (iter=2; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+8);      
     for (iter=2; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+9);      
     WritePixel(rportboard, atx+6, aty+7);
     WritePixel(rportboard, atx+6, aty+8);
     }
      if (numhouses[prop] == 4)
         {
     for (iter=0; iter<2; iter++)  WritePixel(rportboard, atx+iter, aty+12);     
     for (iter=2; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+10);     
     for (iter=2; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+11);     
     for (iter=2; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+12);     
     WritePixel(rportboard, atx+6, aty+10);
     WritePixel(rportboard, atx+6, aty+11);
     }
      } 
   if (orient == 1)
      {
      if (numhouses[prop] == 1)
         {
     for (iter=2; iter<8; iter++)  WritePixel(rportboard, atx+iter, aty);     
     for (iter=2; iter<8; iter++)  WritePixel(rportboard, atx+iter, aty+3);       
     for (iter=1; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+1);       
     for (iter=1; iter<6; iter++)  WritePixel(rportboard, atx+iter, aty+2);
     }
      if (numhouses[prop] >= 2)
         {
     WritePixel(rportboard, atx+1, aty+1);        
     WritePixel(rportboard, atx+1, aty+2);        
     WritePixel(rportboard, atx+1, aty+4);        
     WritePixel(rportboard, atx+1, aty+5);
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+2, aty+iter);       
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+3, aty+iter);       
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+4, aty+iter);       
     for (iter=0; iter<7; iter++)  WritePixel(rportboard, atx+5, aty+iter); 
     for (iter=6; iter<8; iter++)  WritePixel(rportboard, atx+iter, aty); 
     for (iter=6; iter<8; iter++)  WritePixel(rportboard, atx+iter, aty+3); 
     for (iter=6; iter<8; iter++)  WritePixel(rportboard, atx+iter, aty+6);
     }
      if (numhouses[prop] >= 3)
         {
     WritePixel(rportboard, atx+1, aty+7);        
     WritePixel(rportboard, atx+1, aty+8);        
     for (iter=7; iter<9; iter++)  WritePixel(rportboard, atx+2, aty+iter);       
     for (iter=7; iter<9; iter++)  WritePixel(rportboard, atx+3, aty+iter);       
     for (iter=7; iter<9; iter++)  WritePixel(rportboard, atx+4, aty+iter);       
     for (iter=7; iter<9; iter++)  WritePixel(rportboard, atx+5, aty+iter); 
     for (iter=2; iter<8; iter++)  WritePixel(rportboard, atx+iter, aty+9);
     }    
     if (numhouses[prop] == 4)
         {
     WritePixel(rportboard, atx+1, aty+10);       
     WritePixel(rportboard, atx+1, aty+11);       
     for (iter=9; iter<13; iter++)  WritePixel(rportboard, atx+2, aty+iter);      
     for (iter=9; iter<13; iter++)  WritePixel(rportboard, atx+3, aty+iter);      
     for (iter=9; iter<13; iter++)  WritePixel(rportboard, atx+4, aty+iter);      
     for (iter=9; iter<13; iter++)  WritePixel(rportboard, atx+5, aty+iter); 
     for (iter=6; iter<8; iter++)  WritePixel(rportboard, atx+iter, aty+12);
     }
      }
   }
if (!draw)
   {
   SetAPen(rportboard, bg);
   if (!orient)  RectFill(rportboard, atx, aty, atx+17, aty+5);
   if (orient)  RectFill(rportboard, atx, aty, atx+7, aty+12);
   }
if (!notplaying[0])  AddBob(Redbob, &screen1->RastPort);
if (!notplaying[1]) AddBob(Greenbob, &screen1->RastPort);
if (!notplaying[2]) AddBob(Bluebob, &screen1->RastPort);
if (!notplaying[3]) AddBob(Yellowbob, &screen1->RastPort);
WaitTOF();
DrawGels();
}

VOID em(prop, draw)
USHORT prop;
BOOL draw;
{
USHORT bg, atx, aty, pen;
USHORT iter;

/*  draw or erase M in white or black  */
if (prop == 1)
   {
   bg=purple;
   pen=white;
   atx=246;
   aty=172;
   goto drawm;
   }
if (prop == 3)
   {
   bg=purple;
   pen=white;
   atx=205;
   aty=172;
   goto drawm;
   }
if (prop == 6)
   {
   bg=lt_blue;
   pen=black;
   atx=129;
   aty=172;
   goto drawm;
   }
if (prop == 8)
   {
   bg=lt_blue;
   pen=black;
   atx=87;
   aty=172;
   goto drawm;
   }
if (prop == 9)
   {
   bg=lt_blue;
   pen=black;
   atx=67;
   aty=172;
   goto drawm;
   }
if (prop == 11)
   {
   bg=maroon;
   pen=black;
   atx=52;
   aty=162;
   goto drawm;
   }
if (prop == 13)
   {
   bg=maroon;
   pen=black;
   atx=52;
   aty=129;
   goto drawm;
   }
if (prop == 14)
   {
   bg=maroon;
   pen=black;
   atx=52;
   aty=115;
   goto drawm;
   }
if (prop == 16)
   {
   bg=orange;
   pen=white;
   atx=52;
   aty=77;
   goto drawm;
   }
if (prop == 18)
   {
   bg=orange;
   pen=white;
   atx=52;
   aty=47;
   goto drawm;
   }
if (prop == 19)
   {
   bg=orange;
   pen=white;
   atx=52;
   aty=32;
   goto drawm;
   }
if (prop == 21)
   {
   bg=red;
   pen=white;
   atx=66;
   aty=21;
   goto drawm;
   }
if (prop == 23)
   {
   bg=red;
   pen=white;
   atx=109;
   aty=21;
   goto drawm;
   }
if (prop == 24)
   {
   bg=red;
   pen=white;
   atx=129;
   aty=21;
   goto drawm;
   }
if (prop == 26)
   {
   bg=yellow;
   pen=black;
   atx=185;
   aty=21;
   goto drawm;
   }
if (prop == 27)
   {
   bg=yellow;
   pen=black;
   atx=204;
   aty=21;
   goto drawm;
   }
if (prop == 29)
   {
   bg=yellow;
   pen=black;
   atx=247;
   aty=21;
   goto drawm;
   }
if (prop == 31)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=32;
   goto drawm;
   }
if (prop == 32)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=47;
   goto drawm;
   }
if (prop == 34)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=77;
   goto drawm;
   }
if (prop == 37)
   {
   bg=dk_blue;
   pen=white;
   atx=260;
   aty=133;
   goto drawm;
   }
if (prop == 39)
   {
   bg=dk_blue;
   pen=white;
   atx=260;
   aty=162;
   goto drawm;
   }
if (prop == 5)
   {
   bg=somegray;
   pen=red;
   atx=157;
   aty=172;
   goto drawm;
   }
if (prop == 15)
   {
   bg=somegray;
   pen=red;
   atx=52;
   aty=95;
   goto drawm;
   }
if (prop == 25)
   {
   bg=somegray;
   pen=red;
   atx=157;
   aty=21;
   goto drawm;
   }
if (prop == 35)
   {
   bg=somegray;
   pen=red;
   atx=260;
   aty=95;
   goto drawm;
   }
if (prop == 12)
   {
   bg=somegray;
   pen=red;
   atx=52;
   aty=149;
   goto drawm;
   }
if (prop == 28)
   {
   bg=somegray;
   pen=red;
   atx=228;
   aty=21;
   }
drawm:
if (!notplaying[0])  RemIBob(Redbob, &screen1->RastPort, vport1);
if (!notplaying[1])  RemIBob(Greenbob, &screen1->RastPort, vport1);
if (!notplaying[2])  RemIBob(Bluebob, &screen1->RastPort, vport1);
if (!notplaying[3])  RemIBob(Yellowbob, &screen1->RastPort, vport1);
if (draw)
   {
   SetAPen(rportboard, pen);
   WritePixel(rportboard, atx, aty);
   WritePixel(rportboard, atx+1, aty);
   WritePixel(rportboard, atx+6, aty);
   WritePixel(rportboard, atx+7, aty);
   WritePixel(rportboard, atx, aty+1);
   WritePixel(rportboard, atx+1, aty+1);
   WritePixel(rportboard, atx+2, aty+1);
   WritePixel(rportboard, atx+5, aty+1);
   WritePixel(rportboard, atx+6, aty+1);
   WritePixel(rportboard, atx+7, aty+1);
   for (iter=0; iter<8; iter++)   WritePixel(rportboard, atx+iter, aty+2);
   WritePixel(rportboard, atx, aty+3);
   WritePixel(rportboard, atx+1, aty+3);
   WritePixel(rportboard, atx+3, aty+3);
   WritePixel(rportboard, atx+4, aty+3);
   WritePixel(rportboard, atx+6, aty+3);
   WritePixel(rportboard, atx+7, aty+3);
   for (iter=4; iter<6; iter++)
      {
      WritePixel(rportboard, atx, aty+iter);
      WritePixel(rportboard, atx+1, aty+iter);
      WritePixel(rportboard, atx+6, aty+iter);
      WritePixel(rportboard, atx+7, aty+iter);
      }
   }
if (!draw)
   {
   SetAPen(rportboard, bg);
   RectFill(rportboard, atx, aty, atx+7, aty+5);
   }
if (!notplaying[0])  AddBob(Redbob, &screen1->RastPort);
if (!notplaying[1]) AddBob(Greenbob, &screen1->RastPort);
if (!notplaying[2]) AddBob(Bluebob, &screen1->RastPort);
if (!notplaying[3]) AddBob(Yellowbob, &screen1->RastPort);
WaitTOF();
DrawGels();
}

VOID drawhotel(prop, draw)
USHORT prop;
BOOL draw;
{
USHORT bg, atx, aty, orient, pen;
USHORT iter;

if (prop == 1)
   {
   bg=purple;
   pen=white;
   atx=243;
   aty=172;
   orient=0;
   goto drawhot;
   }
if (prop == 3)
   {
   bg=purple;
   pen=white;
   atx=202;
   aty=172;
   orient=0;
   goto drawhot;
   }
if (prop == 6)
   {
   bg=lt_blue;
   pen=black;
   atx=127;
   aty=172;
   orient=0;
   goto drawhot;
   }
if (prop == 8)
   {
   bg=lt_blue;
   pen=black;
   atx=85;
   aty=172;
   orient=0;
   goto drawhot;
   }
if (prop == 9)
   {
   bg=lt_blue;
   pen=black;
   atx=65;
   aty=172;
   orient=0;
   goto drawhot;
   }
if (prop == 11)
   {
   bg=maroon;
   pen=black;
   atx=54;
   aty=159;
   orient=1;
   goto drawhot;
   }
if (prop == 13)
   {
   bg=maroon;
   pen=black;
   atx=54;
   aty=126;
   orient=1;
   goto drawhot;
   }
if (prop == 14)
   {
   bg=maroon;
   pen=black;
   atx=54;
   aty=112;
   orient=1;
   goto drawhot;
   }
if (prop == 16)
   {
   bg=orange;
   pen=white;
   atx=54;
   aty=73;
   orient=1;
   goto drawhot;
   }
if (prop == 18)
   {
   bg=orange;
   pen=white;
   atx=54;
   aty=44;
   orient=1;
   goto drawhot;
   }
if (prop == 19)
   {
   bg=orange;
   pen=white;
   atx=54;
   aty=29;
   orient=1;
   goto drawhot;
   }
if (prop == 21)
   {
   bg=red;
   pen=white;
   atx=64;
   aty=21;
   orient=0;
   goto drawhot;
   }
if (prop == 23)
   {
   bg=red;
   pen=white;
   atx=106;
   aty=21;
   orient=0;
   goto drawhot;
   }
if (prop == 24)
   {
   bg=red;
   pen=white;
   atx=127;
   aty=21;
   orient=0;
   goto drawhot;
   }
if (prop == 26)
   {
   bg=yellow;
   pen=black;
   atx=181;
   aty=21;
   orient=0;
   goto drawhot;
   }
if (prop == 27)
   {
   bg=yellow;
   pen=black;
   atx=202;
   aty=21;
   orient=0;
   goto drawhot;
   }
if (prop == 29)
   {
   bg=yellow;
   pen=black;
   atx=245;
   aty=21;
   orient=0;
   goto drawhot;
   }
if (prop == 31)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=29;
   orient=2;
   goto drawhot;
   }
if (prop == 32)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=44;
   orient=2;
   goto drawhot;
   }
if (prop == 34)
   {
   bg=green;
   pen=black;
   atx=260;
   aty=74;
   orient=2;
   goto drawhot;
   }
if (prop == 37)
   {
   bg=dk_blue;
   pen=white;
   atx=260;
   aty=129;
   orient=2;
   goto drawhot;
   }
if (prop == 39)
   {
   bg=dk_blue;
   pen=white;
   atx=260;
   aty=159;
   orient=2;
   }
drawhot:
if (!notplaying[0])  RemIBob(Redbob, &screen1->RastPort, vport1);
if (!notplaying[1])  RemIBob(Greenbob, &screen1->RastPort, vport1);
if (!notplaying[2])  RemIBob(Bluebob, &screen1->RastPort, vport1);
if (!notplaying[3])  RemIBob(Yellowbob, &screen1->RastPort, vport1);
if (draw)
   {
   SetAPen(rportboard, pen);
   if (orient == 0)
      {
      for (iter=2; iter<5; iter++)   WritePixel(rportboard, atx+iter, aty);
      for (iter=7; iter<10; iter++)  WritePixel(rportboard, atx+iter, aty);
      for (iter=2; iter<5; iter++)   WritePixel(rportboard, atx+iter, aty+1);
      for (iter=7; iter<10; iter++)  WritePixel(rportboard, atx+iter, aty+1);
      for (iter=2; iter<10; iter++)  WritePixel(rportboard, atx+iter, aty+2);
      for (iter=0; iter<12; iter++)  WritePixel(rportboard, atx+iter, aty+3);
      for (iter=0; iter<12; iter++)  WritePixel(rportboard, atx+iter, aty+4);
      for (iter=0; iter<12; iter++)  WritePixel(rportboard, atx+iter, aty+5);
      if (pen == white)   SetAPen(rportboard, black);
      if (pen == black)   SetAPen(rportboard, white);
      WritePixel(rportboard, atx+5, aty+4);
      WritePixel(rportboard, atx+6, aty+4);
      WritePixel(rportboard, atx+5, aty+5);
      WritePixel(rportboard, atx+6, aty+5);
      }
   if (orient == 1)
      {
      for (iter=3; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty);
      for (iter=3; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+1);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+2);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+3);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+4);
      for (iter=2; iter<4; iter++)   WritePixel(rportboard, atx+iter, aty+5);
      for (iter=2; iter<4; iter++)   WritePixel(rportboard, atx+iter, aty+6);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+7);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+8);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+9);
      for (iter=3; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+10);
      for (iter=3; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+11);
      if (pen == white)   SetAPen(rportboard, black);
      if (pen == black)   SetAPen(rportboard, white);
      for (iter=4; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+5);
      for (iter=4; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+6);
      }
   if (orient == 2)
      {
      for (iter=0; iter<3; iter++)   WritePixel(rportboard, atx+iter, aty);
      for (iter=0; iter<3; iter++)   WritePixel(rportboard, atx+iter, aty+1);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+2);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+3);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+4);
      for (iter=2; iter<4; iter++)   WritePixel(rportboard, atx+iter, aty+5);
      for (iter=2; iter<4; iter++)   WritePixel(rportboard, atx+iter, aty+6);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+7);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+8);
      for (iter=0; iter<6; iter++)   WritePixel(rportboard, atx+iter, aty+9);
      for (iter=0; iter<3; iter++)   WritePixel(rportboard, atx+iter, aty+10);
      for (iter=0; iter<3; iter++)   WritePixel(rportboard, atx+iter, aty+11);
      if (pen == white)   SetAPen(rportboard, black);
      if (pen == black)   SetAPen(rportboard, white);
      for (iter=0; iter<2; iter++)   WritePixel(rportboard, atx+iter, aty+5);
      for (iter=0; iter<2; iter++)   WritePixel(rportboard, atx+iter, aty+6);
      }
   }
if (!draw)
   {
   SetAPen(rportboard, bg);
   if (!orient)  RectFill(rportboard, atx, aty, atx+11, aty+5);
   if (orient)  RectFill(rportboard, atx, aty, atx+5, aty+11);
   drawhouse(prop, TRUE);
   }
if (!notplaying[0])  AddBob(Redbob, &screen1->RastPort);
if (!notplaying[1]) AddBob(Greenbob, &screen1->RastPort);
if (!notplaying[2]) AddBob(Bluebob, &screen1->RastPort);
if (!notplaying[3]) AddBob(Yellowbob, &screen1->RastPort);
WaitTOF();
DrawGels();
}




USHORT servicetransmenu(menu, item, sub)
USHORT menu, item, sub;
{
pickedprop=TRUE;
/*   serve the transact menus by returning the property number  */
if (menu != 0)
   {
   return(99);
   }
if (item == 0)
   {
   if (sub == 0)
      {
      return(1);
      }
   if (sub == 1)
      {
      return(3);
      }
   }
if (item == 1)
   {
   if (sub == 0)
      {
      return(6);
      }
   if (sub == 1)
      {
      return(8);
      }
   if (sub == 2)
      {
      return(9);
      }
   }
if (item == 2)
   {
   if (sub == 0)
      {
      return(11);
      }
   if (sub == 1)
      {
      return(13);
      }
   if (sub == 2)
      {
      return(14);
      }
   }
if (item == 3)
   {
   if (sub == 0)
      {
      return(16);
      }
   if (sub == 1)
      {
      return(18);
      }
   if (sub == 2)
      {
      return(19);
      }
   }
if (item == 4)
   {
   if (sub == 0)
      {
      return(21);
      }
   if (sub == 1)
      {
      return(23);
      }
   if (sub == 2)
      {
      return(24);
      }
   }
if (item == 5)
   {
   if (sub == 0)
      {
      return(26);
      }
   if (sub == 1)
      {
      return(27);
      }
   if (sub == 2)
      {
      return(29);
      }
   }
if (item == 6)
   {
   if (sub == 0)
      {
      return(31);
      }
   if (sub == 1)
      {
      return(32);
      }
   if (sub == 2)
      {
      return(34);
      }
   }
if (item == 7)
   {
   if (sub == 0)
      {
      return(37);
      }
   if (sub == 1)
      {
      return(39);
      }
   }
if (item == 8)
   {
   if (sub == 0)
      {
      return(5);
      }
   if (sub == 1)
      {
      return(15);
      }
   if (sub == 2)
      {
      return(25);
      }
   if (sub == 3)
      {
      return(35);
      }
   }
if (item == 9)
   {
   if (sub == 0)
      {
      return(12);
      }
   if (sub == 1)
      {
      return(28);
      }
   }
return(99);
}


