/*  f15.c contains these functions for MONOPOLY:  newgame(),  file_request(),
oldgame(),  
*/


#include "mono:defines"
#include "mono:xvariables"


VOID newgame()
{
struct IntuiText prompt, yesprompt, noprompt;
int iter;

CMes(&prompt, 5, 5, "FORGET GAME IN PROGRESS?", orange, 1);
CMes(&yesprompt, 6, 4, "YES", green, 1);
CMes(&noprompt, 6, 4, "NO", red, 1);
if (!(AutoRequest(boardwindow, &prompt, &yesprompt, &noprompt, NULL, NULL,
                      220, 50)))  return(NULL);


   /*  restore all variables to beginning state  */
if (!notplaying[0])  RemIBob(Redbob, &screen1->RastPort, vport1);
if (!notplaying[1])  RemIBob(Greenbob, &screen1->RastPort, vport1);
if (!notplaying[2])  RemIBob(Bluebob, &screen1->RastPort, vport1);
if (!notplaying[3])  RemIBob(Yellowbob, &screen1->RastPort, vport1);

bankroll[0]=1500L; 
bankroll[1]=1500L; 
bankroll[2]=1500L; 
bankroll[3]=1500L; 
bankroll[5]=999999L;
building=FALSE;
mortgaging=FALSE;
done=FALSE;
doublerr=FALSE;
doubleutil=FALSE;
jaildoubled=FALSE;
trieddoubles=FALSE;
trydoublethrice=FALSE;
doublesrolled=FALSE;
isinjail[0]=FALSE;
isinjail[1]=FALSE;
isinjail[2]=FALSE;
isinjail[3]=FALSE;
for (iter=0; iter<4; iter++)
   {
   playerat[iter]=0;
   freecard[iter]=0;
   jaildouble[iter]=0;
   }
numdoubles=0;

shuffle(0);
shuffle(1);
fillattr();
getplayerinfo();
nsp=ntp;
(VOID) random_start();
OffMenu(boardwindow, 35);
OffMenu(boardwindow, 67);
OffMenu(boardwindow, 99);
OffMenu(boardwindow, 66);
writeyourturn();
if (ntp == 2) 
   {
   notplaying[0]=FALSE;
   notplaying[1]=FALSE;
   notplaying[2]=TRUE;
   notplaying[3]=TRUE;
   }
if (ntp == 3) 
   {
   notplaying[0]=FALSE;
   notplaying[1]=FALSE;
   notplaying[2]=FALSE;
   notplaying[3]=TRUE;
   }
if (ntp == 4) 
   {
   notplaying[0]=FALSE;
   notplaying[1]=FALSE;
   notplaying[2]=FALSE;
   notplaying[3]=FALSE;
   }
bob();
REDX=   go[0][0];
REDY=   go[1][0];
GREENX= go[0][1];
GREENY= go[1][1];
if ((ntp == 3) || (ntp ==4))
   {
   BLUEX=  go[0][2];
   BLUEY=  go[1][2];
   }
if (ntp == 4)
   {
   YELLOWX=go[0][3];
   YELLOWY=go[1][3];
   } 
WaitTOF();
DrawGels();
ClearMenuStrip(boardwindow);
makemenu();
SetMenuStrip(boardwindow, &Menu0);
while (!done)
   {
   if (1<<boardwindow->UserPort->mp_SigBit)   ckmanemsg();
   }   
}


UBYTE *file_request(mode)
USHORT mode;
{
if (mode != 0)  return((UBYTE *)"ram:mono.save");
}

USHORT oldgame()
{
struct FileHandle *restoreptr;
struct FileLock *restore_lock;
char   *Crestore_buffer, *Nrestore_buffer;
USHORT *USrestore_buffer;
SHORT  *Srestore_buffer;
BOOL   *Brestore_buffer;
LONG   *Lrestore_buffer;
int length1, length2, length4, length35, iter;
UBYTE *file_name;

length1=1;
length2=2;
length4=4;
length35=35;

wait_LS.Screen = screen1;
wait_LS.Title = (UBYTE *)"PLEASE WAIT";
if ((waitwindow=(struct Window *)OpenWindow(&wait_LS))==NULL) cleanup();
rportwait=waitwindow->RPort;
SetRast(rportwait, yellow);

Srestore_buffer=(SHORT *)AllocMem(length2, MEMF_CHIP|MEMF_CLEAR);
if (Srestore_buffer == 0)
   {
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"Could not allocate enough memory.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(ALLOCMEM_FAILED);
   }

Brestore_buffer=(BOOL *)AllocMem(length2, MEMF_CHIP|MEMF_CLEAR);
if (Brestore_buffer == 0)
   {
   FreeMem(Srestore_buffer, length2);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"Could not allocate enough memory.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(ALLOCMEM_FAILED);
   }
USrestore_buffer=(USHORT *)AllocMem(length2, MEMF_CHIP|MEMF_CLEAR);
if (USrestore_buffer == 0)
   {
   FreeMem(Srestore_buffer, length2);
   FreeMem(Brestore_buffer, length2);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"Could not allocate enough memory.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(ALLOCMEM_FAILED);
   }

Crestore_buffer=(char *)AllocMem(length1, MEMF_CHIP|MEMF_CLEAR);
if (Crestore_buffer == 0)
   {
   FreeMem(Srestore_buffer, length2);
   FreeMem(Brestore_buffer, length2);
   FreeMem(USrestore_buffer, length2);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"Could not allocate enough memory.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(ALLOCMEM_FAILED);
   }
Nrestore_buffer=(char *)AllocMem(length35, MEMF_CHIP|MEMF_CLEAR);
if (Nrestore_buffer == 0)
   {
   FreeMem(Srestore_buffer, length2);
   FreeMem(Brestore_buffer, length2);
   FreeMem(USrestore_buffer, length2);
   FreeMem(Crestore_buffer, length1);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"Could not allocate enough memory.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(ALLOCMEM_FAILED);
   }
Lrestore_buffer=(LONG *)AllocMem(length4, MEMF_CHIP|MEMF_CLEAR);
if (Lrestore_buffer == 0)
   {
   FreeMem(Srestore_buffer, length2);
   FreeMem(Brestore_buffer, length2);
   FreeMem(USrestore_buffer, length2);
   FreeMem(Crestore_buffer, length1);
   FreeMem(Nrestore_buffer, length35);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"Could not allocate enough memory.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(ALLOCMEM_FAILED);
   }

if ((file_name=file_request(LOAD_IT)) == 0)
   {
   FreeMem(Srestore_buffer, length2);
   FreeMem(Brestore_buffer, length2);
   FreeMem(USrestore_buffer, length2);
   FreeMem(Crestore_buffer, length1);
   FreeMem(Nrestore_buffer, length35);
   FreeMem(Lrestore_buffer, length4);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"     Invalid file name.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(NO_FILE_TO_LOAD);
   }



if ((restore_lock=Lock(file_name, ACCESS_READ))==0)
   {
   UnLock(restore_lock);
   FreeMem(Srestore_buffer, length2);
   FreeMem(Brestore_buffer, length2);
   FreeMem(USrestore_buffer, length2);
   FreeMem(Crestore_buffer, length1);
   FreeMem(Nrestore_buffer, length35);
   FreeMem(Lrestore_buffer, length4);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"     Cannot LOCK file.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(CANT_LOCK_LOAD_FILE);
   }

if ((restoreptr=Open(file_name, MODE_OLDFILE))==0)
   {
   UnLock(restore_lock);
   FreeMem(Srestore_buffer, length2);
   FreeMem(Brestore_buffer, length2);
   FreeMem(USrestore_buffer, length2);
   FreeMem(Crestore_buffer, length1);
   FreeMem(Nrestore_buffer, length35);
   FreeMem(Lrestore_buffer, length4);
   wait_LStext1.FrontPen=red;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
   wait_LStext2.IText=(UBYTE *)"     Cannot OPEN file.";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(OPEN_FILE_FAILED);
   }
else
   {
   wait_LStext1.IText=(UBYTE *)"Now Loading File...";
   wait_LStext2.IText=file_name;
   PrintIText(rportwait, &wait_LStext1, 0,0);

   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x4d)
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x4f)
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x4e)
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x4f)
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x53)
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x41)
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x56)
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   Read(restoreptr, Crestore_buffer, length1);
   if (Crestore_buffer[0]!=0x45) 
      {
      UnLock(restore_lock);
      FreeMem(Srestore_buffer, length2);
      FreeMem(Brestore_buffer, length2);
      FreeMem(USrestore_buffer, length2);
      FreeMem(Crestore_buffer, length1);
      FreeMem(Nrestore_buffer, length35);
      FreeMem(Lrestore_buffer, length4);
      Close(restoreptr);
      SetRast(rportwait, yellow);
      wait_LStext1.FrontPen=red;
      wait_LStext1.BackPen=lt_gray;
      wait_LStext1.DrawMode=JAM2;
      wait_LStext1.IText=(UBYTE *)"      LOAD ABORTED!!!";
      wait_LStext2.IText=(UBYTE *)" Not a Monopoly save file!";
      PrintIText(rportwait, &wait_LStext1, 0,0);
      Delay(200);
      CloseWindow(waitwindow);
      return(BAD_HEADER);
      }
   if (!notplaying[0])  RemIBob(Redbob, &screen1->RastPort, vport1);
   if (!notplaying[1])  RemIBob(Greenbob, &screen1->RastPort, vport1);
   if (!notplaying[2])  RemIBob(Bluebob, &screen1->RastPort, vport1);
   if (!notplaying[3])  RemIBob(Yellowbob, &screen1->RastPort, vport1);

               /*   DATA   */     
   Read(restoreptr, Srestore_buffer, length2);  
   REDX=Srestore_buffer[0];
   Read(restoreptr, Srestore_buffer, length2);  
   REDY=Srestore_buffer[0];
   Read(restoreptr, Srestore_buffer, length2);  
   GREENX=Srestore_buffer[0];
   Read(restoreptr, Srestore_buffer, length2);  
   GREENY=Srestore_buffer[0];
   Read(restoreptr, Srestore_buffer, length2);  
   BLUEX=Srestore_buffer[0];
   Read(restoreptr, Srestore_buffer, length2);  
   BLUEY=Srestore_buffer[0];
   Read(restoreptr, Srestore_buffer, length2);  
   YELLOWX=Srestore_buffer[0];
   Read(restoreptr, Srestore_buffer, length2);  
   YELLOWY=Srestore_buffer[0];
   FreeMem(Srestore_buffer, length2);

   Read(restoreptr, Brestore_buffer, length2);   
   done=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   doublerr=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   doubleutil=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   jaildoubled=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   trieddoubles=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   trydoublethrice=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   doublesrolled=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   isinjail[0]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   isinjail[1]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   isinjail[2]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   isinjail[3]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   notplaying[0]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   notplaying[1]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   notplaying[2]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   notplaying[3]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[0]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[1]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[2]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[3]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[4]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[5]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[6]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[7]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[8]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[9]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[10]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[11]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[12]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[13]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[14]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[15]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[16]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[17]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[18]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[19]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[20]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[21]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[22]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[23]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[24]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[25]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[26]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[27]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[28]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[29]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[30]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[31]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[32]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[33]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[34]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[35]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[36]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[37]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[38]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismono[39]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[0]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[1]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[2]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[3]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[4]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[5]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[6]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[7]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[8]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[9]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[10]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[11]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[12]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[13]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[14]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[15]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[16]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[17]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[18]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[19]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[20]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[21]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[22]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[23]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[24]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[25]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[26]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[27]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[28]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[29]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[30]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[31]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[32]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[33]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[34]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[35]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[36]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[37]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[38]=Brestore_buffer[0];
   Read(restoreptr, Brestore_buffer, length2);   
   ismorg[39]=Brestore_buffer[0];
   FreeMem(Brestore_buffer, length2);

   Read(restoreptr, USrestore_buffer, length2);  
   nhp=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   ncp=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   ntp=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   nsp=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   nowrolling=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numdoubles=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   typeplayer0=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   typeplayer1=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   typeplayer2=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   typeplayer3=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   playerat[0]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   playerat[1]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   playerat[2]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   playerat[3]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   freecard[0]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   freecard[1]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   freecard[2]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   freecard[3]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numutil[0]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numutil[1]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numutil[2]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numutil[3]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numrr[0]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numrr[1]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numrr[2]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numrr[3]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   jaildouble[0]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   jaildouble[1]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   jaildouble[2]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   jaildouble[3]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[0]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[1]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[2]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[3]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[4]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[5]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[6]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[7]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[8]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[9]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[10]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[11]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[12]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[13]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[14]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[15]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[16]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[17]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[18]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[19]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[20]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[21]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[22]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[23]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[24]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[25]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[26]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[27]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[28]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[29]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[30]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[31]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[32]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[33]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[34]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[35]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[36]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[37]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[38]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   owner[39]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[0]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[1]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[2]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[3]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[4]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[5]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[6]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[7]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[8]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[9]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[10]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[11]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[12]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[13]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[14]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[15]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[16]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[17]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[18]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[19]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[20]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[21]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[22]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[23]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[24]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[25]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[26]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[27]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[28]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[29]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[30]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[31]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[32]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[33]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[34]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[35]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[36]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[37]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[38]=USrestore_buffer[0];
   Read(restoreptr, USrestore_buffer, length2);   
   numhouses[39]=USrestore_buffer[0];
   FreeMem(USrestore_buffer, length2);

   Read(restoreptr, Nrestore_buffer, length35);
   for (iter=0; iter<35; iter++)  name0[iter]=Nrestore_buffer[iter];
   Read(restoreptr, Nrestore_buffer, length35);
   for (iter=0; iter<35; iter++)  name1[iter]=Nrestore_buffer[iter];
   Read(restoreptr, Nrestore_buffer, length35);
   for (iter=0; iter<35; iter++)  name2[iter]=Nrestore_buffer[iter];
   Read(restoreptr, Nrestore_buffer, length35);
   for (iter=0; iter<35; iter++)  name3[iter]=Nrestore_buffer[iter];
   FreeMem(Nrestore_buffer, length35);
   
   Read(restoreptr, Lrestore_buffer, length4);
   bankroll[0]=Lrestore_buffer[0];
   Read(restoreptr, Lrestore_buffer, length4);
   bankroll[1]=Lrestore_buffer[0];
   Read(restoreptr, Lrestore_buffer, length4);
   bankroll[2]=Lrestore_buffer[0];
   Read(restoreptr, Lrestore_buffer, length4);
   bankroll[3]=Lrestore_buffer[0];
   Read(restoreptr, Lrestore_buffer, length4);
   bankroll[4]=Lrestore_buffer[0];
   Read(restoreptr, Lrestore_buffer, length4);
   bankroll[5]=Lrestore_buffer[0];
   FreeMem(Lrestore_buffer, length4);
   
   Close(restoreptr);
   UnLock(restore_lock);

   if (!notplaying[0])  AddBob(Redbob, &screen1->RastPort);
   if (!notplaying[1]) AddBob(Greenbob, &screen1->RastPort);
   if (!notplaying[2]) AddBob(Bluebob, &screen1->RastPort);
   if (!notplaying[3]) AddBob(Yellowbob, &screen1->RastPort);
   if  (nowrolling == 0)
      {
      cname.FrontPen=25;
      cname.IText=&name0[0];
      }
   if  (nowrolling == 1)
      {
      cname.FrontPen=26;
      cname.IText=&name1[0];
      }
   if  (nowrolling == 2)
      {   
      cname.FrontPen=27;
      cname.IText=&name2[0];
      }
   if  (nowrolling == 3)
      {
      cname.FrontPen=28;
      cname.IText=&name3[0];
      }
   writeyourturn();
   WaitTOF();
   DrawGels();
   SetRast(rportwait, yellow);
   wait_LStext1.FrontPen=green;
   wait_LStext2.FrontPen=green;
   wait_LStext1.BackPen=lt_gray;
   wait_LStext2.BackPen=lt_gray;
   wait_LStext1.DrawMode=JAM2;
   wait_LStext2.DrawMode=JAM2;
   wait_LStext1.IText=file_name;
   wait_LStext2.IText=(UBYTE *)"Sucessfully Loaded!";
   PrintIText(rportwait, &wait_LStext1, 0,0);
   Delay(200);
   CloseWindow(waitwindow);
   return(GAME_RESTORED);
   }
}
