/* f2.c contains functions for monopoly   
        tax(),  auctionprop(),  fillodstr()
        overdrawn(),  usefreecard(),  trydoubles(),  payfine(),
        servicemenu(),  ckpropinfomsg(),  outofgame(),  fillattr(),
    makeauctionmenu(),   fixauctionmenu(),
    servicepropmenu(menu, item, sub)    */
 
#include "mono:defines"
#include "mono:xvariables"

VOID fixauctionmenu()
{
OffMenu(auctionwindow, 0);
OffMenu(auctionwindow, 2048);
if (nsp > 2) OffMenu(auctionwindow, 4096);
if (nsp > 3) OffMenu(auctionwindow, 6144);
if (!notplaying[0])  OnMenu(auctionwindow, 0);
if (!notplaying[1])  OnMenu(auctionwindow, 2048);
if (!notplaying[2])  OnMenu(auctionwindow, 4096);
if (!notplaying[3])  OnMenu(auctionwindow, 6144);
}


VOID tax()
{
USHORT iter;
USHORT cost;
cost=0;
for (iter=0; iter<40; iter++)
   {
   if (owner[iter] == nowrolling)
      {
      cost=cost+propcost[iter];
      cost=cost+(numhouses[iter]*housecost[iter]);
      }
   }
cost=cost+(freecard[nowrolling]*50);
cost=cost+bankroll[nowrolling];
eft(nowrolling, SLUSH, (cost/10) );
}
   
USHORT auction(which)
USHORT which;
{
ULONG aclass;
struct IntuiText address, msg0, msg1, msg2, msg3, msg4, msg5, msg6,
                 msg7, msg8, msg9, dollar, msg10, nobid_text;
struct StringInfo bidinfo;
struct Border nobidborder;
USHORT nobidbord[10], acode, hold_line;
aclass=0;
acode=0;

nobidbord[0]=-1;
nobidbord[1]=-1;
nobidbord[2]=57;
nobidbord[3]=-1;
nobidbord[4]=57;
nobidbord[5]=10;
nobidbord[6]=-1;
nobidbord[7]=10;
nobidbord[8]=-1;
nobidbord[9]=-1;

nobidborder.LeftEdge=0;
nobidborder.TopEdge=0;
nobidborder.FrontPen=green;
nobidborder.BackPen=black;
nobidborder.DrawMode=JAM1;
nobidborder.Count=5;
nobidborder.XY=&nobidbord[0];
nobidborder.NextBorder=NULL;

nobid_text.FrontPen=green;
nobid_text.BackPen=black;
nobid_text.DrawMode=JAM1;
nobid_text.TopEdge=1;
nobid_text.LeftEdge=1;
nobid_text.IText=(UBYTE *)"NO BIDS";
nobid_text.ITextFont=NULL;
nobid_text.NextText=NULL;

address.BackPen=black;
address.DrawMode=JAM1;
address.TopEdge=0;
address.LeftEdge=5;
address.ITextFont=NULL;
address.NextText=&msg0;

msg0.FrontPen=dk_maroon;
msg0.BackPen=black;
msg0.DrawMode=JAM1;
msg0.TopEdge=10;
msg0.LeftEdge=5;
msg0.IText=(UBYTE *)"is for sale to the";
msg0.ITextFont=NULL;
msg0.NextText=&msg1;

msg1.FrontPen=dk_maroon;
msg1.BackPen=black;
msg1.DrawMode=JAM1;
msg1.TopEdge=20;
msg1.LeftEdge=5;
msg1.IText=(UBYTE *)"highest bidder.  Please";
msg1.ITextFont=NULL;
msg1.NextText=&msg2;

msg2.FrontPen=dk_maroon;
msg2.BackPen=black;
msg2.DrawMode=JAM1;
msg2.TopEdge=30;
msg2.LeftEdge=5;
msg2.IText=(UBYTE *)"bid amongst yourselves,";
msg2.ITextFont=NULL;
msg2.NextText=&msg3;

msg3.FrontPen=dk_maroon;
msg3.BackPen=black;
msg3.DrawMode=JAM1;
msg3.TopEdge=40;
msg3.LeftEdge=5;
msg3.IText=(UBYTE *)"then enter the high";
msg3.ITextFont=NULL;
msg3.NextText=&msg4;

msg4.FrontPen=dk_maroon;
msg4.BackPen=black;
msg4.DrawMode=JAM1;
msg4.TopEdge=50;
msg4.LeftEdge=5;
msg4.IText=(UBYTE *)"bid below by clicking";
msg4.ITextFont=NULL;
msg4.NextText=&msg5;

msg5.FrontPen=dk_maroon;
msg5.BackPen=black;
msg5.DrawMode=JAM1;
msg5.TopEdge=60;
msg5.LeftEdge=5;
msg5.IText=(UBYTE *)"on the number and";
msg5.ITextFont=NULL;
msg5.NextText=&msg6;

msg6.FrontPen=dk_maroon;
msg6.BackPen=black;
msg6.DrawMode=JAM1;
msg6.TopEdge=70;
msg6.LeftEdge=5;
msg6.IText=(UBYTE *)"deleting it, then enter";
msg6.ITextFont=NULL;
msg6.NextText=&msg7;

msg7.FrontPen=dk_maroon;
msg7.BackPen=black;
msg7.DrawMode=JAM1;
msg7.TopEdge=80;
msg7.LeftEdge=5;
msg7.IText=(UBYTE *)"the bid.  Next, use the";
msg7.ITextFont=NULL;
msg7.NextText=&msg8;

msg8.FrontPen=dk_maroon;
msg8.BackPen=black;
msg8.DrawMode=JAM1;
msg8.TopEdge=89;
msg8.LeftEdge=5;
msg8.IText=(UBYTE *)"MENU to name the";
msg8.ITextFont=NULL;
msg8.NextText=&msg9;

msg9.FrontPen=dk_maroon;
msg9.BackPen=black;
msg9.DrawMode=JAM1;
msg9.TopEdge=98;
msg9.LeftEdge=5;
msg9.IText=(UBYTE *)"winning bidder.";
msg9.ITextFont=NULL;
msg9.NextText=&dollar;

dollar.FrontPen=red;
dollar.BackPen=black;
dollar.DrawMode=JAM2;
dollar.TopEdge=109;
dollar.LeftEdge=41;
dollar.IText=(UBYTE *)"$";
dollar.ITextFont=NULL;
dollar.NextText=NULL;

msg10.FrontPen=maroon;
msg10.BackPen=black;
msg10.DrawMode=JAM1;
msg10.TopEdge=115;
msg10.LeftEdge=28;
msg10.IText=(UBYTE *)"IS THIS CORRECT?";
msg10.ITextFont=NULL;
msg10.NextText=NULL;

nobidgag.NextGadget=NULL;
nobidgag.LeftEdge=50;
nobidgag.TopEdge=130;
nobidgag.Width=56;
nobidgag.Height=10;
nobidgag.Flags=GADGHCOMP;
nobidgag.Activation=GADGIMMEDIATE | RELVERIFY;
nobidgag.GadgetType=BOOLGADGET;
nobidgag.GadgetRender=(APTR)&nobidborder;
nobidgag.SelectRender=NULL;
nobidgag.GadgetText=&nobid_text;
nobidgag.MutualExclude=NULL;
nobidgag.SpecialInfo=NULL;
nobidgag.GadgetID=8;
nobidgag.UserData=NULL;

bidgag.NextGadget=&nobidgag;
bidgag.LeftEdge=50;
bidgag.TopEdge=109;
bidgag.Width=53;
bidgag.Height=10;
bidgag.Flags=GADGHNONE;
bidgag.Activation=LONGINT | GADGIMMEDIATE;
bidgag.GadgetType=STRGADGET;
bidgag.GadgetRender=(APTR)&bidborder;
bidgag.SelectRender=NULL;
bidgag.GadgetText=NULL;
bidgag.MutualExclude=NULL;
bidgag.SpecialInfo=(APTR)&bidinfo;
bidgag.GadgetID=9;
bidgag.UserData=NULL;

bidinfo.Buffer=nbufbid;
bidinfo.UndoBuffer=undobufi;
bidinfo.MaxChars=6;
bidinfo.BufferPos=0;
bidinfo.DispPos=0;
bidinfo.LongInt=0;

if (which == 1)
   {
   address.IText=(UBYTE *)"MEDITERRANEAN AVENUE";
   address.FrontPen=purple;
   }

if (which == 3)
   {
   address.IText=(UBYTE *)"BALTIC AVENUE";
   address.FrontPen=purple;
   }

if (which == 5)
   {
   address.IText=(UBYTE *)"READING RR";
   address.FrontPen=flesh;
   }

if (which == 6)
   {
   address.IText=(UBYTE *)"ORIENTAL AVENUE";
   address.FrontPen=lt_blue;
   }

if (which == 8)
   {
   address.IText=(UBYTE *)"VERMONT AVENUE";
   address.FrontPen=lt_blue;
   }

if (which == 9)
   {
   address.IText=(UBYTE *)"CONNECTICUT  AVENUE";
   address.FrontPen=lt_blue;
   }

if (which == 11)
   {
   address.IText=(UBYTE *)"ST. CHARLES PLACE";
   address.FrontPen=maroon;
   }

if (which == 12)
   {
   address.IText=(UBYTE *)"ELECTRIC COMPANY";
   address.FrontPen=yellow;
   }

if (which == 13)
   {
   address.IText=(UBYTE *)"STATES  AVENUE";
   address.FrontPen=maroon;
   }

if (which == 14)
   {
   address.IText=(UBYTE *)"VIRGINIA AVENUE";
   address.FrontPen=maroon;
   }

if (which == 15)
   {
   address.IText=(UBYTE *)"PENNSYLVANIA RR";
   address.FrontPen=flesh;
   }

if (which == 16)
   {
   address.IText=(UBYTE *)"ST. JAMES PLACE";
   address.FrontPen=orange;
   }

if (which == 18)
   {
   address.IText=(UBYTE *)"TENNESSEE AVENUE";
   address.FrontPen=orange;
   }

if (which == 19)
   {
   address.IText=(UBYTE *)"NEW YORK AVENUE";
   address.FrontPen=orange;
   }

if (which == 21)
   {
   address.IText=(UBYTE *)"KENTUCKY AVENUE";
   address.FrontPen=red;
   }

if (which == 23)
   {
   address.IText=(UBYTE *)"INDIANA AVENUE";
   address.FrontPen=red;
   }

if (which == 24)
   {
   address.IText=(UBYTE *)"ILLINOIS AVENUE";
   address.FrontPen=red;
   }

if (which == 25)
   {
   address.IText=(UBYTE *)"B. & O. RR";
   address.FrontPen=flesh;
   }

if (which == 26)
   {
   address.IText=(UBYTE *)"ATLANTIC AVENUE";
   address.FrontPen=yellow;
   }

if (which == 27)
   {
   address.IText=(UBYTE *)"VENTNOR AVENUE";
   address.FrontPen=yellow;
   }

if (which == 28)
   {
   address.IText=(UBYTE *)"WATER WORKS";
   address.FrontPen=royal_blue;
   }

if (which == 29)
   {
   address.IText=(UBYTE *)"MARVIN GARDENS";
   address.FrontPen=yellow;
   }

if (which == 31)
   {
   address.IText=(UBYTE *)"PACIFIC AVENUE";
   address.FrontPen=green;
   }

if (which == 32)
   {
   address.IText=(UBYTE *)"NORTH CAROLINA AVENUE";
   address.FrontPen=green;
   }

if (which == 34)
   {
   address.IText=(UBYTE *)"PENNSYLVANIA AVENUE";
   address.FrontPen=green;
   }

if (which == 35)
   {
   address.IText=(UBYTE *)"SHORT LINE";
   address.FrontPen=flesh;
   }

if (which == 37)
   {
   address.IText=(UBYTE *)"PARK PLACE";
   address.FrontPen=dk_blue;
   }

if (which == 39)
   {
   address.IText=(UBYTE *)"BOARDWALK";
   address.FrontPen=dk_blue;
   }

nauctionw.Screen=screen1;
nauctionw.IDCMPFlags=MENUPICK | GADGETUP | RAWKEY;
nauctionw.FirstGadget=&bidgag;
if ((auctionwindow=(struct Window *)OpenWindow(&nauctionw))==NULL) cleanup();
rportauction=auctionwindow->RPort;
SetMenuStrip(auctionwindow, &Menu12);
fixauctionmenu();

PrintIText(rportauction, &address, 0, 0);

line0_text=159;   /*   AUCTION PROP  */
for (j=0, hold_line=line0_text; j<SHOW_LINES; j++)
    instructIT[j].IText=instructline[hold_line++];

recheckamsg:
Wait(1<<auctionwindow->UserPort->mp_SigBit);

while((auctionmsg=(struct IntuiMessage *)
                         GetMsg(auctionwindow->UserPort))!=NULL)
   {
   aclass=auctionmsg->Class;
   acode=auctionmsg->Code;
   if (aclass == GADGETUP)   getID(auctionmsg);
   ReplyMsg(auctionmsg);
   }
if ( (aclass == RAWKEY) && (acode == HELP) )
   {
   instruction();
   goto recheckamsg;
   }
if ( (aclass == GADGETUP) && (gagid == 8) )   return(NOBIDS);
if ( (aclass == MENUPICK) && (acode == MENUNULL) )  goto recheckamsg;
if ( (aclass == MENUPICK) && (acode != MENUNULL) )
   {
   if (MENUNUM(acode) == 1)
      {
      if (ITEMNUM(acode) == 0)  reviewprop();
      if (ITEMNUM(acode) == 1)  viewdeeds();
      if (ITEMNUM(acode) == 2)  moneybags(SUBNUM(acode));
      goto recheckamsg;
      }
   ClearMenuStrip(auctionwindow);
   CloseWindow(auctionwindow);
   yesgag.TopEdge=130;
   nogag.TopEdge=130;
   yesgag.LeftEdge=145;
   nogag.LeftEdge=10;
   buyee=ITEMNUM(acode);
   bidcost=bidinfo.LongInt;
   if (buyee == 0)
      {
      msg4.IText=&name0[0];
      msg4.FrontPen=25;
      }
   if (buyee == 1)
      {
      msg4.IText=&name1[0];
      msg4.FrontPen=26;
      }
   if (buyee == 2)
      { 
      msg4.IText=&name2[0];
      msg4.FrontPen=27;
      }
   if (buyee == 3)
      {
      msg4.IText=&name3[0];
      msg4.FrontPen=28;
      }
   msg0.IText=(UBYTE *)"has been auctioned";
   msg1.IText=(UBYTE *)"off to the highest";
   msg2.IText=(UBYTE *)"bidder.";
   msg3.IText=(UBYTE *)" ";
   msg5.IText=(UBYTE *)"won the bidding";
   msg6.IText=(UBYTE *)"with a bid of:";
   msg7.IText=(UBYTE *)"$";
   msg8.IText=&nbufbid[0];
   msg9.IText=(UBYTE *)" ";
   msg0.FrontPen=brite_green;
   msg1.FrontPen=brite_green;
   msg2.FrontPen=brite_green;
   msg3.FrontPen=brite_green;
   msg5.FrontPen=brite_green;
   msg6.FrontPen=brite_green;
   msg7.FrontPen=red;
   msg8.FrontPen=red;
   msg8.TopEdge=80;
   msg8.LeftEdge=14;
   msg9.NextText=&msg10;
   nauctionw.FirstGadget=&yesgag;
   nauctionw.IDCMPFlags=GADGETUP | RAWKEY;
   if ((auctionwindow=(struct Window *)OpenWindow(&nauctionw))==NULL) cleanup();
   rportauction=auctionwindow->RPort;
   PrintIText(rportauction, &address, 0, 0);

   line0_text=173;   /*   AUCTION PROP  */
   for (j=0, hold_line=line0_text; j<SHOW_LINES; j++)
     instructIT[j].IText=instructline[hold_line++];

   getamsgagain:
   Wait(1<<auctionwindow->UserPort->mp_SigBit);

   while((auctionmsg=(struct IntuiMessage *)
                         GetMsg(auctionwindow->UserPort))!=NULL)
      {
      aclass=auctionmsg->Class;
      acode=auctionmsg->Code;
      if (aclass == GADGETUP)  getID(auctionmsg);
      ReplyMsg(auctionmsg);
      }
   if ( (aclass == RAWKEY) && (acode == HELP) )
      {
      instruction();
      goto getamsgagain;
      }
   if ( (aclass == GADGETUP) && (gagid == YES) )   return(GOODBID);
   if ( (aclass == GADGETUP) && (gagid == NO) )   return(BADBID);
   }
}

VOID auctionprop(which)
USHORT which;
{
USHORT action;

bid=TRUE;
while (bid)
   {
   action=auction(which);
   if (action == NOBIDS)
      {
      ClearMenuStrip(auctionwindow);
      (VOID)RemoveGadget(auctionwindow, &bidgag);
      (VOID)RemoveGadget(auctionwindow, &nobidgag);
      CloseWindow(auctionwindow);
      owner[which]=9;
      bid=FALSE;
      }
   if (action == GOODBID)
      {
      CloseWindow(auctionwindow);
      transfertitle((USHORT)buyee, BANK, which, (USHORT)bidcost);
      bid=FALSE;
      }
   if (action == BADBID)  CloseWindow(auctionwindow);
   }
}

VOID fillodstr()
{
(VOID) stcl_d(odamount, lamount);
SetAPen(rportoverdrawn, black);
RectFill(rportoverdrawn, 83, 70, 192, 80);
}

VOID overdrawn(who, amountneeded)
USHORT who, amountneeded;   /*  amount will be size of debt   */
{
struct IntuiText odname, warn, odwad, dollarsign, useM, useM1,
                 pqname, pqprompt, pqyesprompt, pqnoprompt;
ULONG odclass, odcode;
LONG startdollar;

odclass=0;
odcode=0;

startdollar=bankroll[who];  
lamount=( (LONG)amountneeded-bankroll[who] );


pqname.BackPen=black;
pqname.DrawMode=JAM1;
pqname.LeftEdge=5;
pqname.TopEdge=5;
pqname.ITextFont=NULL;
pqname.NextText=&pqprompt;

pqprompt.BackPen=black;
pqprompt.DrawMode=JAM1;
pqprompt.LeftEdge=5;
pqprompt.TopEdge=15;
pqprompt.IText=(UBYTE *)"Will YOU quit the game?";
pqprompt.ITextFont=NULL;
pqprompt.NextText=NULL;

pqyesprompt.BackPen=red;
pqyesprompt.DrawMode=JAM1;
pqyesprompt.LeftEdge=6;
pqyesprompt.TopEdge=4;
pqyesprompt.IText=(UBYTE *)"QUIT";
pqyesprompt.ITextFont=NULL;
pqyesprompt.NextText=NULL;

pqnoprompt.BackPen=green;
pqnoprompt.DrawMode=JAM1;
pqnoprompt.LeftEdge=6;
pqnoprompt.TopEdge=4;
pqnoprompt.IText=(UBYTE *)"PLAY";
pqnoprompt.ITextFont=NULL;
pqnoprompt.NextText=NULL;

if (who == 0)
   {
   pqprompt.FrontPen=25;
   pqname.FrontPen=25;
   odname.FrontPen=25;
   odname.IText=&name0[0]; 
   pqname.IText=&name0[0]; 
   }
if  (who == 1)
   {
   pqprompt.FrontPen=26;
   pqname.FrontPen=26;
   odname.FrontPen=26;
   odname.IText=&name1[0];
   pqname.IText=&name1[0];
   }
if  (who == 2)
   {   
   pqprompt.FrontPen=27;
   pqname.FrontPen=27;
   odname.FrontPen=27;
   odname.IText=&name2[0];
   pqname.IText=&name2[0];
   }
if  (who == 3)
   {
   pqprompt.FrontPen=28;
   pqname.FrontPen=28;
   odname.FrontPen=28;
   odname.IText=&name3[0];
   pqname.IText=&name3[0];
   }

odname.BackPen=black;
odname.DrawMode=JAM1;
odname.LeftEdge=5;
odname.TopEdge=35;
odname.ITextFont=NULL;
odname.NextText=&warn;

warn.FrontPen=maroon;
warn.BackPen=black;
warn.DrawMode=JAM1;
warn.LeftEdge=5;
warn.TopEdge=55;
warn.IText=(UBYTE *)"YOU ARE OVER DRAWN!";
warn.ITextFont=NULL;
warn.NextText=&useM;

dollarsign.FrontPen=red;
dollarsign.BackPen=black;
dollarsign.DrawMode=JAM1;
dollarsign.LeftEdge=5;
dollarsign.TopEdge=70;
dollarsign.IText=(UBYTE *)"You need $";
dollarsign.ITextFont=NULL;
dollarsign.NextText=&odwad;

odwad.FrontPen=red;
odwad.BackPen=black;
odwad.DrawMode=JAM1;
odwad.LeftEdge=85;
odwad.TopEdge=70;
odwad.ITextFont=NULL;
odwad.NextText=NULL;

useM.FrontPen=dk_maroon;
useM.BackPen=black;
useM.DrawMode=JAM1;
useM.LeftEdge=5;
useM.TopEdge=90;
useM.IText=(UBYTE *)"      USE THE MENU";
useM.ITextFont=NULL;
useM.NextText=&useM1;

useM1.FrontPen=dk_maroon;
useM1.BackPen=black;
useM1.DrawMode=JAM1;
useM1.LeftEdge=5;
useM1.TopEdge=100;
useM1.IText=(UBYTE *)"    TO OBTAIN FUNDS.";
useM1.ITextFont=NULL;
useM1.NextText=NULL;


noverdrawnw.Screen=screen1;
if ((overdrawnwindow=(struct Window *)OpenWindow(&noverdrawnw))==NULL) 
     cleanup();
rportoverdrawn=overdrawnwindow->RPort;
SetMenuStrip(overdrawnwindow, &Menu10);
fixodmenu();

fillodstr();
odwad.IText=&odamount[0];

PrintIText(rportoverdrawn, &odname, 0, 0);
PrintIText(rportoverdrawn, &dollarsign, 0, 0);

doneod=FALSE;
while (!doneod)
   {
   if (1<<overdrawnwindow->UserPort->mp_SigBit)
      {
      while((overdrawnmsg=(struct IntuiMessage *)
                         GetMsg(overdrawnwindow->UserPort))!=NULL)
         {
         odclass=overdrawnmsg->Class;
         odcode=overdrawnmsg->Code;
         ReplyMsg(overdrawnmsg);
   
         if (odclass == CLOSEWINDOW)
            {
        if (odqpflag || building || mortgaging)
           {
           doneod=TRUE;
           goto excloseW;
           }
            doneod=(AutoRequest(overdrawnwindow, &pqname, &pqyesprompt, 
                &pqnoprompt, NULL, NULL, 215, 60));
        excloseW:
            }

         if ( (odclass == MENUPICK) && (odcode != MENUNULL) )
            {
        if ( (MENUNUM(odcode) == 0) && (ITEMNUM(odcode) == 0) )  
           buildhouse(SUBNUM(odcode));
            if ( (MENUNUM(odcode) == 0) && (ITEMNUM(odcode) == 1) )  
           sellhouse(SUBNUM(odcode));
            if ( (MENUNUM(odcode) == 0) && (ITEMNUM(odcode) == 2) )  
           makemortgage(SUBNUM(odcode));
            if ( (MENUNUM(odcode) == 0) && (ITEMNUM(odcode) == 3) )  
           liftmortgage(SUBNUM(odcode));
            if ( (MENUNUM(odcode) == 0) && (ITEMNUM(odcode) == 4) )  
           reviewprop();
            if ( (MENUNUM(odcode) == 0) && (ITEMNUM(odcode) == 5) )  
           viewdeeds();
            if ( (MENUNUM(odcode) == 1) && (ITEMNUM(odcode) == 0) )  
           (VOID)offersell();
            if ( (MENUNUM(odcode) == 1) && (ITEMNUM(odcode) == 1) )  
           (VOID)offerbuy();
            if ( (MENUNUM(odcode) == 1) && (ITEMNUM(odcode) == 2) )  
               moneybags(SUBNUM(odcode));
            if (startdollar != bankroll[who])
           {
           if (bankroll[who] <= amountneeded)
              {
          lamount=( (LONG)amountneeded-bankroll[who] );
                  fillodstr();
          odwad.IText=&odamount[0];
          startdollar=bankroll[who];
              PrintIText(rportoverdrawn, &odwad, 0, 0);
          }
               if (bankroll[who] >= amountneeded)
              {
          SetAPen(rportoverdrawn, black);
          RectFill(rportoverdrawn, 0, 50, 192, 112);
          warn.IText=(UBYTE *)"YOU ARE NOT OVERDRAWN.";
          warn.NextText=NULL;
          PrintIText(rportoverdrawn, &warn, 0, 0);
          Delay(75);
          doneod=TRUE;
          }
           }
            }
         }
      }
   }
ClearMenuStrip(overdrawnwindow);
CloseWindow(overdrawnwindow);
}


VOID usefreecard()
{
freecard[nowrolling]--;
if  (nowrolling == 0)
   {
   REDX=vis[0][nowrolling];
   REDY=vis[1][nowrolling];
   }
if  (nowrolling == 1)
   {
   GREENX=vis[0][nowrolling];
   GREENY=vis[1][nowrolling];
   }
if  (nowrolling == 2)
   {
   BLUEX=vis[0][nowrolling];
   BLUEY=vis[1][nowrolling];
   }
if  (nowrolling == 3)
   {
   YELLOWX=vis[0][nowrolling];
   YELLOWY=vis[1][nowrolling];
   }
isinjail[nowrolling]=FALSE;
WaitTOF();
DrawGels();
playerat[nowrolling]=10;
fixmenu();
}

VOID outofgame(player, in_favor_of)
USHORT player, in_favor_of;
{
USHORT iter;

notplaying[player]=TRUE;
ntp--;
for (iter=0; iter<40; iter++)
   {
   if (owner[iter] == player)
      {
      if ( (iter == 12) || (iter == 28) )
         {
     if ( (in_favor_of != BANK) && (in_favor_of != SLUSH) )
        numutil[in_favor_of]++;
         }
      if ( (iter == 5) || (iter == 15) || (iter == 25) || (iter ==35) )
         {
     if ( (in_favor_of != BANK) && (in_favor_of != SLUSH) )
            numrr[in_favor_of]++;
         }
      if (numhouses[iter] > 0)
         {
     eft(BANK, player, (housecost[iter]/2)*numhouses[iter]);
         drawhouse(iter, FALSE);
         numhouses[iter]=0;
     }
      if ( (in_favor_of != BANK) && (in_favor_of != SLUSH) )
         {
         transfertitle(in_favor_of, player, iter, 0);
     }
      if ( (in_favor_of == BANK) || (in_favor_of == SLUSH) )
         {
     auctionprop(iter);
     }
      }
   }
numutil[player]=0;
numrr[player]=0;
eft(player, in_favor_of, bankroll[player]);
if (player == 0)
   {
   RemIBob(Redbob, &screen1->RastPort, vport1);
   typeplayer0=DEAD;
   }
if (player == 1)
   {
   RemIBob(Greenbob, &screen1->RastPort, vport1);
   typeplayer1=DEAD;
   }
if (player == 2)
   {
   RemIBob(Bluebob, &screen1->RastPort, vport1);
   typeplayer2=DEAD;
   }
if (player == 3)
   {
   RemIBob(Yellowbob, &screen1->RastPort, vport1);
   typeplayer3=DEAD;
   }
}

VOID payfine()
{
if (bankroll[nowrolling]<50)  overdrawn(nowrolling, 50);
if (bankroll[nowrolling]<50)
   {
   outofgame(nowrolling);
   goto expayfine;
   }
bankroll[nowrolling]=bankroll[nowrolling]-50;
if (nowrolling == 0)
   {
   REDX=vis[0][nowrolling];
   REDY=vis[1][nowrolling];
   }
if (nowrolling == 1)
   {
   GREENX=vis[0][nowrolling];
   GREENY=vis[1][nowrolling];
   }
if (nowrolling == 2)
   {
   BLUEX=vis[0][nowrolling];
   BLUEY=vis[1][nowrolling];
   }
if (nowrolling == 3)
   {
   YELLOWX=vis[0][nowrolling];
   YELLOWY=vis[1][nowrolling];
   }
isinjail[nowrolling]=FALSE;
WaitTOF();
DrawGels();
playerat[nowrolling]=10;
fixmenu();
expayfine:
}

VOID trydoubles()
{
jaildouble[nowrolling]++;
trieddoubles=TRUE;
dice0=rolldie();
dice1=rolldie();
dicecup(TRUE);
drawdice();
if (dice0 == dice1)
   {
   jaildouble[nowrolling]=0;
   jaildoubled=TRUE;
   trieddoubles=FALSE;
   if  (nowrolling == 0)
      {
      REDX=vis[0][nowrolling];
      REDY=vis[1][nowrolling];
      }
   if  (nowrolling == 1)
      {
      GREENX=vis[0][nowrolling];
      GREENY=vis[1][nowrolling];
      }
   if  (nowrolling == 2)
      {
      BLUEX=vis[0][nowrolling];
      BLUEY=vis[1][nowrolling];
      }
   if  (nowrolling == 3)
      {
      YELLOWX=vis[0][nowrolling];
      YELLOWY=vis[1][nowrolling];
      }
   isinjail[nowrolling]=FALSE;
   WaitTOF();
   DrawGels();
   fixmenu();
   playerat[nowrolling]=10;
   }
if (jaildouble[nowrolling] == 3)
   {
   payfine();
   trydoublethrice=TRUE;
   trieddoubles=FALSE;
   jaildouble[nowrolling]=0;
   }
roll();
}

VOID servicemenu(menu, item, sub)
USHORT menu, item, sub;
{
USHORT test_filer;

    /*  set up a menu server here  */
   if ((menu == 0) && (item == 0))  changecolors(); 
   if ((menu == 0) && (item == 1))  newgame();
   if ((menu == 0) && (item == 2))
      {
      test_filer=oldgame();
      if (test_filer == GAME_RESTORED)
      if (test_filer != GAME_RESTORED)
printf("load error %d\n", test_filer);
      }  
   if ((menu == 0) && (item == 3))
      {
      test_filer=savegame();
      if (test_filer == GAME_SAVED)
      if (test_filer != GAME_SAVED)
printf("save error %d\n", test_filer);
      }
   if ((menu == 0) && (item == 4))  endgame();
   if ((menu == 1) && (item == 0))  buildhouse(sub);   /*   1  */ 
   if ((menu == 1) && (item == 1))  sellhouse(sub);    /*  33  */
   if ((menu == 1) && (item == 2))  makemortgage(sub); /*  65  */
   if ((menu == 1) && (item == 3))  liftmortgage(sub); /*  97  */
   if ((menu == 1) && (item == 4))  reviewprop();
   if ((menu == 1) && (item == 5))  viewdeeds();
   if ((menu == 2) && (item == 0))  offersell();
   if ((menu == 2) && (item == 1))  offerbuy();
   if ((menu == 2) && (item == 2))  moneybags(sub);
   if ((menu == 3) && (item == 0))  roll();         /*   3  */
   if ((menu == 3) && (item == 1))  usefreecard();  /*  35  */
   if ((menu == 3) && (item == 2))  trydoubles();   /*  67  */
   if ((menu == 3) && (item == 3))  payfine();      /*  99  */
}

VOID servicepropmenu(menu, item, sub)
USHORT menu, item, sub;
{
if ( (menu == 0) && (item == 0) )  buildhouse(sub);
if ( (menu == 0) && (item == 1) )  sellhouse(sub);
if ( (menu == 0) && (item == 2) )  makemortgage(sub);
if ( (menu == 0) && (item == 3) )  liftmortgage(sub);
if ( (menu == 0) && (item == 4) )  reviewprop();
if ( (menu == 0) && (item == 5) )  viewdeeds();
if ( (menu == 1) && (item == 0) )  (VOID)offersell();
if ( (menu == 1) && (item == 1) )  (VOID)offerbuy();
if ( (menu == 1) && (item == 2) )  moneybags(sub);
}

VOID ckpropinfomsg()
{
ULONG pclass;
USHORT pcode;
pclass=0;
pcode=0;

recheckpropm:
while (propinfomsg=(struct IntuiMessage *)GetMsg(propinfowindow->UserPort))
   {
   pclass = propinfomsg->Class;
   pcode  = propinfomsg->Code; 
   if (pclass == GADGETUP)  getID(propinfomsg);   
   ReplyMsg(propinfomsg);
   if ( (pclass == RAWKEY) && (pcode == HELP) ) instruction();
   if (pclass == GADGETUP)
      {
      buyfrombank=FALSE;
      if (gagid == 0)  donepropinfo=TRUE;
      if (gagid == 1)
         {
         buyfrombank=TRUE;
         donepropinfo=TRUE;
         }
      if (gagid == 2)
         {
     donepropinfo=TRUE;
     didntbuyfrombank=TRUE;
     }
      if (gagid == 29)
         {
     eft(nowrolling, SLUSH, 200);  /*  $200 income tax  */
     donepropinfo=TRUE;
     }
      if (gagid == 28)
         {
     tax();
     donepropinfo=TRUE;
     }
      }
   if ( (pclass == MENUPICK) && (pcode != MENUNULL) )
      {
      servicepropmenu(MENUNUM(pcode), ITEMNUM(pcode), SUBNUM(pcode));
      goto recheckpropm;
      }
   }
}

VOID fillattr()
{
USHORT iter;

jailvectorlocation22[0][0]=86;
jailvectorlocation22[1][0]=83;
jailvectorlocation22[2][0]=80;
jailvectorlocation22[3][0]=77;
jailvectorlocation22[4][0]=74;
jailvectorlocation22[5][0]=71;
jailvectorlocation22[6][0]=68;
jailvectorlocation22[7][0]=65;
jailvectorlocation22[8][0]=62;
jailvectorlocation22[9][0]=59;
jailvectorlocation22[10][0]=56;
jailvectorlocation22[11][0]=53;
jailvectorlocation22[12][0]=50;
jailvectorlocation22[13][0]=47;
jailvectorlocation22[14][0]=44;
jailvectorlocation22[15][0]=42;
   
jailvectorlocation22[0][1]=10;
jailvectorlocation22[1][1]=20;
jailvectorlocation22[2][1]=32;
jailvectorlocation22[3][1]=43;
jailvectorlocation22[4][1]=55;
jailvectorlocation22[5][1]=66;
jailvectorlocation22[6][1]=78;
jailvectorlocation22[7][1]=89;
jailvectorlocation22[8][1]=101;
jailvectorlocation22[9][1]=112;
jailvectorlocation22[10][1]=124;
jailvectorlocation22[11][1]=135;
jailvectorlocation22[12][1]=147;
jailvectorlocation22[13][1]=158;
jailvectorlocation22[14][1]=170;
jailvectorlocation22[15][1]=178;

jailvectorlocation30[0][1]=10;
jailvectorlocation30[1][1]=15;
jailvectorlocation30[2][1]=20;
jailvectorlocation30[3][1]=25;
jailvectorlocation30[4][1]=30;
jailvectorlocation30[5][1]=35;
jailvectorlocation30[6][1]=40;
jailvectorlocation30[7][1]=45;
jailvectorlocation30[8][1]=50;
jailvectorlocation30[9][1]=55;
jailvectorlocation30[10][1]=60;
jailvectorlocation30[11][1]=65;
jailvectorlocation30[12][1]=70;
jailvectorlocation30[13][1]=75;
jailvectorlocation30[14][1]=80;
jailvectorlocation30[15][1]=85;
jailvectorlocation30[16][1]=90;
jailvectorlocation30[17][1]=95;
jailvectorlocation30[18][1]=100;
jailvectorlocation30[19][1]=105;
jailvectorlocation30[20][1]=110;
jailvectorlocation30[21][1]=115;
jailvectorlocation30[22][1]=120;
jailvectorlocation30[23][1]=125;
jailvectorlocation30[24][1]=130;
jailvectorlocation30[25][1]=135;
jailvectorlocation30[26][1]=140;
jailvectorlocation30[27][1]=145;
jailvectorlocation30[28][1]=150;
jailvectorlocation30[29][1]=155;
jailvectorlocation30[30][1]=160;
jailvectorlocation30[31][1]=165;
jailvectorlocation30[32][1]=170;
jailvectorlocation30[33][1]=175;
jailvectorlocation30[34][1]=179;

jailvectorlocation30[0][0]=273;
jailvectorlocation30[1][0]=266;
jailvectorlocation30[2][0]=259;
jailvectorlocation30[3][0]=252;
jailvectorlocation30[4][0]=245;
jailvectorlocation30[5][0]=239;
jailvectorlocation30[6][0]=232;
jailvectorlocation30[7][0]=225;
jailvectorlocation30[8][0]=218;
jailvectorlocation30[9][0]=211;
jailvectorlocation30[10][0]=204;
jailvectorlocation30[11][0]=198;
jailvectorlocation30[12][0]=191;
jailvectorlocation30[13][0]=184;
jailvectorlocation30[14][0]=177;
jailvectorlocation30[15][0]=170;
jailvectorlocation30[16][0]=163;
jailvectorlocation30[17][0]=157;
jailvectorlocation30[18][0]=150;
jailvectorlocation30[19][0]=143;
jailvectorlocation30[20][0]=136;
jailvectorlocation30[21][0]=129;
jailvectorlocation30[22][0]=122;
jailvectorlocation30[23][0]=116;
jailvectorlocation30[24][0]=109;
jailvectorlocation30[25][0]=102;
jailvectorlocation30[26][0]=95;
jailvectorlocation30[27][0]=88;
jailvectorlocation30[28][0]=81;
jailvectorlocation30[29][0]=75;
jailvectorlocation30[30][0]=68;
jailvectorlocation30[31][0]=61;
jailvectorlocation30[32][0]=54;
jailvectorlocation30[33][0]=47;
jailvectorlocation30[34][0]=42;

jailvectorlocation33[0][1]=62;
jailvectorlocation33[1][1]=66;
jailvectorlocation33[2][1]=70;
jailvectorlocation33[3][1]=74;
jailvectorlocation33[4][1]=78;
jailvectorlocation33[5][1]=82;
jailvectorlocation33[6][1]=86;
jailvectorlocation33[7][1]=90;
jailvectorlocation33[8][1]=94;
jailvectorlocation33[9][1]=98;
jailvectorlocation33[10][1]=102;
jailvectorlocation33[11][1]=106;
jailvectorlocation33[12][1]=110;
jailvectorlocation33[13][1]=114;
jailvectorlocation33[14][1]=118;
jailvectorlocation33[15][1]=122;
jailvectorlocation33[16][1]=126;
jailvectorlocation33[17][1]=130;
jailvectorlocation33[18][1]=134;
jailvectorlocation33[19][1]=138;
jailvectorlocation33[20][1]=142;
jailvectorlocation33[21][1]=146;
jailvectorlocation33[22][1]=150;
jailvectorlocation33[23][1]=154;
jailvectorlocation33[24][1]=158;
jailvectorlocation33[25][1]=162;
jailvectorlocation33[26][1]=166;
jailvectorlocation33[27][1]=170;
jailvectorlocation33[28][1]=174;
jailvectorlocation33[29][1]=178;
jailvectorlocation33[30][1]=179;

jailvectorlocation33[0][0]=273;
jailvectorlocation33[1][0]=265;
jailvectorlocation33[2][0]=257;
jailvectorlocation33[3][0]=249;
jailvectorlocation33[4][0]=241;
jailvectorlocation33[5][0]=233;
jailvectorlocation33[6][0]=225;
jailvectorlocation33[7][0]=217;
jailvectorlocation33[8][0]=209;
jailvectorlocation33[9][0]=201;
jailvectorlocation33[10][0]=194;
jailvectorlocation33[11][0]=186;
jailvectorlocation33[12][0]=178;
jailvectorlocation33[13][0]=170;
jailvectorlocation33[14][0]=162;
jailvectorlocation33[15][0]=154;
jailvectorlocation33[16][0]=146;
jailvectorlocation33[17][0]=138;
jailvectorlocation33[18][0]=130;
jailvectorlocation33[19][0]=122;
jailvectorlocation33[20][0]=115;
jailvectorlocation33[21][0]=107;
jailvectorlocation33[22][0]=99;
jailvectorlocation33[23][0]=91;
jailvectorlocation33[24][0]=83;
jailvectorlocation33[25][0]=75;
jailvectorlocation33[26][0]=67;
jailvectorlocation33[27][0]=59;
jailvectorlocation33[28][0]=51;
jailvectorlocation33[29][0]=43;
jailvectorlocation33[30][0]=42;

jailvectorlocation36[0][1]=117;
jailvectorlocation36[1][1]=120;
jailvectorlocation36[2][1]=123;
jailvectorlocation36[3][1]=126;
jailvectorlocation36[4][1]=129;
jailvectorlocation36[5][1]=132;
jailvectorlocation36[6][1]=135;
jailvectorlocation36[7][1]=138;
jailvectorlocation36[8][1]=141;
jailvectorlocation36[9][1]=144;
jailvectorlocation36[10][1]=147;
jailvectorlocation36[11][1]=150;
jailvectorlocation36[12][1]=153;
jailvectorlocation36[13][1]=156;
jailvectorlocation36[14][1]=159;
jailvectorlocation36[15][1]=162;
jailvectorlocation36[16][1]=165;
jailvectorlocation36[17][1]=168;
jailvectorlocation36[18][1]=171;
jailvectorlocation36[19][1]=174;
jailvectorlocation36[20][1]=177;
jailvectorlocation36[21][1]=179;

jailvectorlocation36[0][0]=273;
jailvectorlocation36[1][0]=260;
jailvectorlocation36[2][0]=249;
jailvectorlocation36[3][0]=238;
jailvectorlocation36[4][0]=227;
jailvectorlocation36[5][0]=216;
jailvectorlocation36[6][0]=205;
jailvectorlocation36[7][0]=193;
jailvectorlocation36[8][0]=182;
jailvectorlocation36[9][0]=171;
jailvectorlocation36[10][0]=160;
jailvectorlocation36[11][0]=149;
jailvectorlocation36[12][0]=138;
jailvectorlocation36[13][0]=126;
jailvectorlocation36[14][0]=115;
jailvectorlocation36[15][0]=104;
jailvectorlocation36[16][0]=93;
jailvectorlocation36[17][0]=82;
jailvectorlocation36[18][0]=70;
jailvectorlocation36[19][0]=59;
jailvectorlocation36[20][0]=48;
jailvectorlocation36[21][0]=41;

for  (iter=0; iter<40; iter++)
   {
   owner[iter]=9;
   propcost[iter]=0;
   numhouses[iter]=0;
   rentnone[iter]=0;
   rentone[iter]=0;
   renttwo[iter]=0;
   rentthree[iter]=0;
   rentfour[iter]=0;
   renthotel[iter]=0;
   housecost[iter]=0;
   ismono[iter]=FALSE;
   ismorg[iter]=FALSE;
   isutil[iter]=FALSE;
   isrr[iter]=FALSE;
   }
for  (iter=0; iter<4; iter++)
   {
   numutil[iter]=0;
   numrr[iter]=0;
   }

isrr[5]=TRUE;
isrr[15]=TRUE;
isrr[25]=TRUE;
isrr[35]=TRUE;   
propcost[5]=200;
propcost[15]=200;
propcost[25]=200;
propcost[35]=200;

isutil[12]=TRUE;
isutil[28]=TRUE;
propcost[12]=150;
propcost[28]=150;


propcost[1]=60;
housecost[1]=50;
rentnone[1]=2;
rentone[1]=10;
renttwo[1]=30;
rentthree[1]=90;
rentfour[1]=160;
renthotel[1]=250;

propcost[3]=60;
housecost[3]=50;
rentnone[3]=4;
rentone[3]=20;
renttwo[3]=60;
rentthree[3]=180;
rentfour[3]=320;
renthotel[3]=450;


propcost[6]=100;
housecost[6]=50;
rentnone[6]=6;
rentone[6]=30;
renttwo[6]=90;
rentthree[6]=270;
rentfour[6]=400;
renthotel[6]=550;


propcost[8]=100;
housecost[8]=50;
rentnone[8]=6;
rentone[8]=30;
renttwo[8]=90;
rentthree[8]=270;
rentfour[8]=400;
renthotel[8]=550;


propcost[9]=120;
housecost[9]=50;
rentnone[9]=8;
rentone[9]=40;
renttwo[9]=100;
rentthree[9]=300;
rentfour[9]=450;
renthotel[9]=600;


propcost[11]=140;
housecost[11]=100;
rentnone[11]=10;
rentone[11]=50;
renttwo[11]=150;
rentthree[11]=450;
rentfour[11]=625;
renthotel[11]=750;


propcost[13]=140;
housecost[13]=100;
rentnone[13]=10;
rentone[13]=50;
renttwo[13]=150;
rentthree[13]=450;
rentfour[13]=625;
renthotel[13]=750;


propcost[14]=160;
housecost[14]=100;
rentnone[14]=12;
rentone[14]=60;
renttwo[14]=180;
rentthree[14]=500;
rentfour[14]=700;
renthotel[14]=900;


propcost[16]=180;
housecost[16]=100;
rentnone[16]=14;
rentone[16]=70;
renttwo[16]=200;
rentthree[16]=550;
rentfour[16]=750;
renthotel[16]=950;


propcost[18]=180;
housecost[18]=100;
rentnone[18]=14;
rentone[18]=70;
renttwo[18]=200;
rentthree[18]=550;
rentfour[18]=750;
renthotel[18]=950;


propcost[19]=200;
housecost[19]=100;
rentnone[19]=16;
rentone[19]=80;
renttwo[19]=220;
rentthree[19]=600;
rentfour[19]=800;
renthotel[19]=1000;


propcost[21]=220;
housecost[21]=150;
rentnone[21]=18;
rentone[21]=90;
renttwo[21]=250;
rentthree[21]=700;
rentfour[21]=875;
renthotel[21]=1050;


propcost[23]=220;
housecost[23]=150;
rentnone[23]=18;
rentone[23]=90;
renttwo[23]=250;
rentthree[23]=700;
rentfour[23]=875;
renthotel[23]=1050;


propcost[24]=240;
housecost[24]=150;
rentnone[24]=20;
rentone[24]=100;
renttwo[24]=300;
rentthree[24]=750;
rentfour[24]=925;
renthotel[24]=1100;


propcost[26]=260;
housecost[26]=150;
rentnone[26]=22;
rentone[26]=110;
renttwo[26]=330;
rentthree[26]=800;
rentfour[26]=975;
renthotel[26]=1150;


propcost[27]=260;
housecost[27]=150;
rentnone[27]=22;
rentone[27]=110;
renttwo[27]=330;
rentthree[27]=800;
rentfour[27]=975;
renthotel[27]=1150;


propcost[29]=280;
housecost[29]=150;
rentnone[29]=24;
rentone[29]=120;
renttwo[29]=360;
rentthree[29]=850;
rentfour[29]=1025;
renthotel[29]=1200;


propcost[31]=300;
housecost[31]=200;
rentnone[31]=26;
rentone[31]=130;
renttwo[31]=390;
rentthree[31]=900;
rentfour[31]=1100;
renthotel[31]=1275;


propcost[32]=300;
housecost[32]=200;
rentnone[32]=26;
rentone[32]=130;
renttwo[32]=390;
rentthree[32]=900;
rentfour[32]=1100;
renthotel[32]=1275;


propcost[34]=320;
housecost[34]=200;
rentnone[34]=28;
rentone[34]=150;
renttwo[34]=450;
rentthree[34]=1000;
rentfour[34]=1200;
renthotel[34]=1400;


propcost[37]=350;
housecost[37]=200;
rentnone[37]=28;
rentone[37]=150;
renttwo[37]=450;
rentthree[37]=1000;
rentfour[37]=1200;
renthotel[37]=1400;


propcost[39]=400;
housecost[39]=200;
rentnone[39]=50;
rentone[39]=200;
renttwo[39]=600;
rentthree[39]=1400;
rentfour[39]=1700;
renthotel[39]=2000;

owner[0]=8;
owner[2]=8;
owner[4]=8;
owner[7]=8;
owner[10]=8;
owner[17]=8;
owner[20]=8;
owner[22]=8;
owner[30]=8;
owner[33]=8;
owner[36]=8;
owner[38]=8;
}



